#include "function_reg.h"
#include <stdlib.h>
#include <assert.h>

void add_function(FunctionRegistry* freg, Function* f) {
   FunctionRegistryEntry* entry = malloc(sizeof(FunctionRegistryEntry));
   assert(entry);
   entry->f = f;
   entry->next = freg->entries; freg->entries = entry;
}

Function* lookup(FunctionRegistry* freg, char* name) {
   FunctionRegistryEntry* entry = freg->entries;
   while (entry && strcmp(entry->f->name, name)) {
      entry = entry->next;
   }
   if (entry) {
      return entry->f;
   } else {
      return 0;
   }
}
